package di_aop.aop.proxy;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.util.Arrays;

public class LoggingInvocationHandler implements
		InvocationHandler {

	private Object target;

	public LoggingInvocationHandler(Object target) {
		this.target = target;
	}

	public Object invoke(Object proxy, Method method,
			Object[] args) throws Throwable {
		System.out.println("BEGIN :"
				+ method.getDeclaringClass().getName() + "#"
				+ method.getName() + "(" + Arrays.asList(args)
				+ ")");
		Object ret = null;
		try {
			ret = method.invoke(target, args);
			return ret;
		} finally {
			System.out.println("END   :"
					+ method.getDeclaringClass().getName() + "#"
					+ method.getName() + " : " + ret);
		}
	}

}
