package di_aop.di.aop.method_missing;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.HashMap;
import java.util.Map;

import org.aopalliance.intercept.MethodInterceptor;
import org.aopalliance.intercept.MethodInvocation;

public class MapIntercepter implements MethodInterceptor {
	private Map<Object, Object> map = new HashMap<Object, Object>();

	public Object invoke(MethodInvocation invocation) throws Throwable {
		Method method = invocation.getMethod();

		if (Modifier.isAbstract(method.getModifiers()) == false) {
			return invocation.proceed();
		}

		String methodName = method.getName();
		Object[] arguments = invocation.getArguments();

		if (methodName.startsWith("get")) {
			Object key = arguments[0];
			return map.get(key);
		} else if (methodName.startsWith("put")) {
			Object key = arguments[0];
			Object value = arguments[1];
			map.put(key, value);
			return null;
		} else {
			throw new UnsupportedOperationException();
		}
	}
}
